function[data,name,Pos,THb]=CellsPosition(TrackX,TrackY,TrackZ,spots_or,b_or,A1,A2,A3,A4)
S=ones(3,size(spots_or,2));
for i=1:(size(spots_or,2))
    S(1,i)=TrackX(i);
    S(2,i)=TrackY(i);
    S(3,i)=TrackZ(i);
end
%% Calculate angular position nuclei
THb=ones(1,size(spots_or,2));
PHIb=THb;
Rb=THb;
for i=1:size(spots_or,2)
    [TH,PHI,R] = cart2sph(S(1,i),S(2,i),S(3,i));
    THb(i)=TH;
    PHIb(i)=PHI;
    Rb(i)=R;
end

A5=(A1+A3)/2;
A6=(A2+A4)/2;
% Define position on cirfumference (only ventral or dorsal)
SIZE=size(spots_or,2);
Pos=cell(1,SIZE);
for i=1:SIZE
    clear Ventral_idx
    clear Dorsal_idx
    P=char(1, length(THb(i)));
    Ventral_idx =find(THb(i)<=(A5) & THb(i)>=(A6)); %Ventral_idx =find(THb{i}<=(pi/2) & THb{i}>=(-pi/2));
    Dorsal_idx  =find(THb(i)>=(A5) | THb(i)<=(A6)); %Dorsal_idx  =find(THb{i}>=(pi-pi/2) | THb{i}<=(-pi+pi/2));
    P(Ventral_idx)='V' %P(Ventral_idx)=P_s(3);
    P(Dorsal_idx)='D' %P(Dorsal_idx)=P_s(1);
    Pos{i}=P;
end

% Number and percentage cells in V D sectors
POV=0;
POD=POV;
for i=1:size(spots_or,2)
    clear p
    p=[Pos{i}];
    if (p(1)=='V')
        POV=POV+1;
    end
    if (p(1)=='D')
        POD=POD+1;
    end
end
TOT=sum([POV;POD]); %tot number of cells
pov=POV; % number cells in ventral half 
POV=POV./TOT; % percentage cells in ventral half
pod=POD; % number cells in dorsal half 
POD=POD./TOT; % percentage cells in dorsal half

% Define angular position on cross section (dorsal, ventral, right, left)
SIZE=size(spots_or,2);
if (b_or(3,1,1)<0) 
    Pos=cell(1,SIZE);
    for i=1:SIZE
        clear Ventral_idx
        clear Dorsal_idx
        clear Right_idx
        clear Left_idx    
            P=char(1, length(THb(i)));
            Ventral_idx =find(THb(i)<=(A1) & THb(i)>=(A2)); 
            Dorsal_idx  =find(THb(i)>=(A3) | THb(i)<=(A4)); 
            Right_idx   =find(THb(i)>(A1)  & THb(i)<(A3));
            Left_idx  =find(THb(i)<(A2) & THb(i)>(A4));   
        P(Left_idx)='L'; 
        P(Ventral_idx)='V'; 
        P(Right_idx)='R'; 
        P(Dorsal_idx)='D'; 
        Pos{i}=P;
    end
else 
    Pos=cell(1,SIZE);
    for i=1:SIZE
        clear Ventral_idx
        clear Dorsal_idx
        clear Right_idx
        clear Left_idx     
            P=char(1, length(THb(i)));
            Ventral_idx =find(THb(i)<=(A1) & THb(i)>=(A2)); 
            Dorsal_idx  =find(THb(i)>=(A3) | THb(i)<=(A4));
            Left_idx   =find(THb(i)>(A1)  & THb(i)<(A3)); 
            Right_idx  =find(THb(i)<(A2) & THb(i)>(A4)); 
        P(Left_idx)='L';
        P(Ventral_idx)='V';
        P(Right_idx)='R';
        P(Dorsal_idx)='D';
        Pos{i}=P;
    end
end

% Number and percentage cells in L R V D sectors
PL=0;
PR=PL;
PV=PR;
PD=PR;
for i=1:SIZE
    clear p
    p=Pos{i};
    if (p(1)=='L')
        PL=PL+1;
    end
    if (p(1)=='R')
        PR=PR+1;
    end
    if (p(1)=='V')
        PV=PV+1;
    end
    if (p(1)=='D')
        PD=PD+1;
    end
end
TOT=sum([PD;PV;PR;PL]);  %tot number of cells
pr=PR; % number cells in right sector
pl=PL; % number cells in left sector
pd=PD; % number cells in dorsal sector
pv=PV; % number cells in ventral sector
PR=PR./TOT; % percentage cells in right sector
PL=PL./TOT; % percentage cells in left sector
PV=PV./TOT; % percentage cells in ventral sector
PD=PD./TOT; % percentage cells in dorsal sector

%% summary of all results
name{1}='% Pos ventral (DV)';
data(1)=POV; % percentage cells in ventral half of the cross section 
name{2}='Pos ventral (DV)';
data(2)=pov; % number cells in ventral half of the cross section 
name{3}='% Pos dorsal (DV)';
data(3)=POD; % percentage cells in dorsal half of the cross section 
name{4}='Pos dorsal (DV)';
data(4)=pod; % number cells in dorsal half of the cross section 
name{5}='% Pos dorsal (DVRL)';
data(5)=PD; % percentage cells in dorsal region of the cross section 
name{6}='Pos dorsal (DVRL)';
data(6)=pd; % number cells in dorsal region of the cross section 
name{7}='% Pos ventral(DVRL)';
data(7)=PV; % percentage cells in ventral region of the cross section 
name{8}='Pos ventral(DVRL)';
data(8)=pv; % number cells in ventral region of the cross section 
name{9}='% Pos left (DVRL)';
data(9)=PL; % percentage cells in left region of the cross section 
name{10}='Pos left (DVRL)';
data(10)=pl; % number cells in left region of the cross section 
name{11}='% Pos right (DVRL)';
data(11)=PR; % percentage cells in right region of the cross section 
name{12}='Pos right (DVRL)';
data(12)=pr; % number cells in right region of the cross section 
name=name';

