function[b,p,xyzt,e1,e2,e3,avgxyz,xyzt_PCV] = DA_ref_system(data_PCV,Ig2t,spots,CylCenter,CylDirection,CylDirectionStart,CylRadiusStart,b1)

avgxyz=Ig2t;
xyzt=spots;
tolp=0.1;
tolg=0.1;
if (CylDirection'*[1;0;0])<0
    CylDirection=-CylDirection; % assumes A (left) and Posterior(right)
end

% Fit PCV cylinder 
xyzt_PCV=data_PCV; %nuclei position   
CylCenterStart_PCV=[nanmean(nanmean(xyzt_PCV(1,:))) nanmean(nanmean(xyzt_PCV(2,:))) nanmean(nanmean(xyzt_PCV(3,:)))]';
[CylCenter_PCV, CylDirection_PCV, CylRadius_PCV] = lscylinder(xyzt_PCV', CylCenterStart_PCV, CylDirectionStart, CylRadiusStart, tolp, tolg);% Requires lsge toolboxes
if CylDirection_PCV'*[1;0;0]<1
    CylDirection_PCV=-CylDirection_PCV; % assumes A (left) and Posterior(right)
end
%% find ref system using PCV and DA axes, and assume that the fish is
% oriented from Anterior(left) to Posterior (right)
% e1 = first  base of the ref system: CylDirection.
e1 = CylDirection/norm(CylDirection);
% e2 = second base of the ref system from CylCenter_PCV-CylCenter (pointing from Dorsal to Ventral: from DA to PCV)
e2 = CylCenter_PCV-CylCenter;
e2 =e2-(e2'*e1)*e1;
e2 =e2/norm(e2);
% e3 = 3rd base of the ref system: vector product e1 e2
e3 =  cross(e1,e2); % pointz toword positive z direction if PCV is above DA and viceversa
e3 = e3/norm(e3);
%% translate to origin
for i=1:size(b1,2)
    b_rot(1,i,:)=b1(1,i,:)-CylCenter(1,:); % traslate DA
    b_rot(2,i,:)=b1(2,i,:)-CylCenter(2,:);
    b_rot(3,i,:)=b1(3,i,:)-CylCenter(3,:);
end
xyzt(1,:,:) =xyzt(1,:,:) -CylCenter(1,:); % traslate DA nuclei
xyzt(2,:,:) =xyzt(2,:,:) -CylCenter(2,:);
xyzt(3,:,:) =xyzt(3,:,:) -CylCenter(3,:);
avgxyz(1,:) =avgxyz(1,:) -CylCenter(1,:); % traslate DA nuclei
avgxyz(2,:) =avgxyz(2,:) -CylCenter(2,:);
avgxyz(3,:) =avgxyz(3,:) -CylCenter(3,:);
xyzt_PCV(1,:)     =xyzt_PCV(1,:)     -CylCenter(1,:); % traslate PCV nuclei
xyzt_PCV(2,:)     =xyzt_PCV(2,:)     -CylCenter(2,:);
xyzt_PCV(3,:)     =xyzt_PCV(3,:)     -CylCenter(3,:);
CylCenter=CylCenter-CylCenter;

% figure
% plot3(squeeze(b_rot(1,1:50:end,:)),squeeze(b_rot(2,1:50:end,:)),squeeze(b_rot(3,1:50:end,:)),'-g')
% hold on
% plot3(squeeze(xyzt(1,1,:)),squeeze(xyzt(2,1,:)),squeeze(xyzt(3,1,:)),'.y','MarkerSize',30)
% plot3(avgxyz(1,:),avgxyz(2,:),avgxyz(3,:),'.r','MarkerSize',30)
% plot3(xyzt_PCV(1,:),xyzt_PCV(2,:),xyzt_PCV(3,:),'.b','MarkerSize',30)
% quiver3(CylCenter(1),CylCenter(2),CylCenter(3),e1(1),e1(2),e1(3),50)
% quiver3(CylCenter(1),CylCenter(2),CylCenter(3),e2(1),e2(2),e2(3),50)
% quiver3(CylCenter(1),CylCenter(2),CylCenter(3),e3(1),e3(2),e3(3),50)
% plot3(squeeze(b_rot(1,1,:)),squeeze(b_rot(2,1,:)),squeeze(b_rot(3,1,:)),'-k')

%% rotate such that e3=[0;0;1]
% rotate around z
[TH,PHI,R] = cart2sph(e2(1),e2(2),e2(3));
xyzt=twod_rotationZ(xyzt,-TH+pi/2);
avgxyz=twod_rotationZ(avgxyz,-TH+pi/2);
xyzt_PCV=twod_rotationZ(xyzt_PCV,-TH+pi/2);
e1=twod_rotationZ(e1,-TH+pi/2);
e2=twod_rotationZ(e2,-TH+pi/2);
e3=twod_rotationZ(e3,-TH+pi/2);
b_rot=twod_rotationZ(b_rot,-TH+pi/2);

% rotate around x
xyzt=twod_rotationx(xyzt,-PHI);
avgxyz=twod_rotationx(avgxyz,-PHI);
xyzt_PCV=twod_rotationx(xyzt_PCV,-PHI);
e1=twod_rotationx(e1,-PHI);
e2=twod_rotationx(e2,-PHI);
e3=twod_rotationx(e3,-PHI);
b_rot=twod_rotationx(b_rot,-PHI);

% rotate around y
[TH,PHI,R] = cart2sph(e1(1),e1(2),e1(3));
xyzt=twod_rotationy(xyzt,PHI);
avgxyz=twod_rotationy(avgxyz,PHI);
xyzt_PCV=twod_rotationy(xyzt_PCV,PHI);
e1=twod_rotationy(e1,PHI);
e2=twod_rotationy(e2,PHI);
e3=twod_rotationy(e3,PHI);
b_rot=twod_rotationy(b_rot,PHI);

% rotate such that e1=[0 0 1]
% rotate around y
xyzt=twod_rotationy(xyzt,-pi/2);
avgxyz=twod_rotationy(avgxyz,-pi/2);
xyzt_PCV=twod_rotationy(xyzt_PCV,-pi/2);
e1=twod_rotationy(e1,-pi/2);
e2=twod_rotationy(e2,-pi/2);
e3=twod_rotationy(e3,-pi/2);
b_rot=twod_rotationy(b_rot,-pi/2);

% rotate around z
xyzt=twod_rotationZ(xyzt,-pi/2);
avgxyz=twod_rotationZ(avgxyz,-pi/2);
xyzt_PCV=twod_rotationZ(xyzt_PCV,-pi/2);
e1=twod_rotationZ(e1,-pi/2);
e2=twod_rotationZ(e2,-pi/2);
e3=twod_rotationZ(e3,-pi/2);
b_rot=twod_rotationZ(b_rot,-pi/2);

% figure
% plot3(squeeze(b_rot(1,1:50:end,:)),squeeze(b_rot(2,1:50:end,:)),squeeze(b_rot(3,1:50:end,:)),'-g')
% hold on
% plot3(squeeze(xyzt(1,1,:)),squeeze(xyzt(2,1,:)),squeeze(xyzt(3,1,:)),'.y','MarkerSize',30)
% plot3(avgxyz(1,:),avgxyz(2,:),avgxyz(3,:),'.r','MarkerSize',30)
% hold on
% plot3(xyzt_PCV(1,:),xyzt_PCV(2,:),xyzt_PCV(3,:),'.b','MarkerSize',30)
% quiver3(CylCenter(1),CylCenter(2),CylCenter(3),e1(1),e1(2),e1(3),50)
% quiver3(CylCenter(1),CylCenter(2),CylCenter(3),e2(1),e2(2),e2(3),50)
% quiver3(CylCenter(1),CylCenter(2),CylCenter(3),e3(1),e3(2),e3(3),50)
% plot3(squeeze(b_rot(1,1,:)),squeeze(b_rot(2,1,:)),squeeze(b_rot(3,1,:)),'-k')
                  
b=b_rot;
% figure
% surf(squeeze(b(1,:,:)),squeeze(b(2,:,:)),squeeze(b(3,:,:)));
% hold all
% quiver3(CylCenter(1),CylCenter(2),CylCenter(3),e3(1),e3(2),e3(3),100)
% quiver3(CylCenter(1),CylCenter(2),CylCenter(3),e2(1),e2(2),e2(3),100)
% quiver3(CylCenter(1),CylCenter(2),CylCenter(3),e1(1),e1(2),e1(3),500)
% plot3(xyzt_PCV(1,:),xyzt_PCV(2,:),xyzt_PCV(3,:),'.b','MarkerSize',30)
% plot3(avgxyz(1,:),avgxyz(2,:),avgxyz(3,:),'.k','MarkerSize',30)
% axis equal

%% %%%           Divide vessel cross section in 4 parts
THb=zeros(size(b,2),size(b,3));
for i=1:size(b,2)
    [THb(i,:),PHIb(i,:),Rb(i,:)] = cart2sph(b(1,i,:),b(2,i,:),b(3,i,:));
end

% Search for most dorsal point
for ic=1:size(b1,2)
    disc(ic)=norm(b(:,ic,1)-CylCenter(:));
end
[~,s]=min(disc);
gaps=linspace(1,30,300);
vcent=zeros(3,length(gaps));
for ig=1:length(gaps)
    vcent(:,ig)=CylCenter(:)-e2(:)*-gaps(ig)*-1;
end
% plot3(vcent(1,:),vcent(2,:),vcent(3,:),'.g')
for ie=1:size(b,3)
    disv(ie)=norm(b(:,s,ie)-vcent(:,300));
end
[~,p]=min(disv);
% plot3(squeeze(b(1,s,p)),squeeze(b(2,s,p)),squeeze(b(3,s,p)),'*w')
[TH,PHI,R] = cart2sph(avgxyz(1,:),avgxyz(2,:),avgxyz(3,:));
Ventral_idx =find(TH<=(pi/4) & TH>=(-pi/4));
Dorsal_idx  =find(TH>=(pi-pi/4) | TH<=(-pi+pi/4)); % ACTUNG: TH goes from -pi to pi
Right_idx   =find(TH>(pi/4)  & TH<(pi-pi/4));
Left_idx  =find(TH<(-pi/4) & TH>(-pi+pi/4));
% hold all
% plot3(avgxyz(1,Dorsal_idx ),avgxyz(2,Dorsal_idx ),avgxyz(3,Dorsal_idx ),'.r','MarkerSize',30)
% plot3(avgxyz(1,Ventral_idx ),avgxyz(2,Ventral_idx ),avgxyz(3,Ventral_idx ),'.g','MarkerSize',30)
% plot3(avgxyz(1,Left_idx ),avgxyz(2,Left_idx ),avgxyz(3,Left_idx ),'.m','MarkerSize',30)
% plot3(avgxyz(1,Right_idx ),avgxyz(2,Right_idx ),avgxyz(3,Right_idx ),'.y','MarkerSize',30)

% for it=1:size(xyzt,2)
%     clear Ventral_idx_it Dorsal_idx_it
%     [th,phi,r] = cart2sph(xyzt(1,it,:),xyzt(2,it,:),xyzt(3,it,:));
%     plot3(squeeze(xyzt(1,it,: )),squeeze(xyzt(2,it,:)),squeeze(xyzt(3,it,: )),'.w')
%     Ventral_idx_it =find(th<=(pi/2) & th>=(-pi/2));
%     Dorsal_idx_it  =find(th>=(pi/2) | th<=(-pi/2)); %
%     plot3(squeeze(xyzt(1,it,Dorsal_idx_it )),squeeze(xyzt(2,it,Dorsal_idx_it )),squeeze(xyzt(3,it,Dorsal_idx_it )),'.r')
%     plot3(squeeze(xyzt(1,it,Ventral_idx_it)),squeeze(xyzt(2,it,Ventral_idx_it)),squeeze(xyzt(3,it,Ventral_idx_it)),'.g')
% end
% xlabel 'DV axis'
% ylabel 'LR axis'
% zlabel 'AP axis'