function [b]=ellipse2np(b,Npl,np0)
close all
N=size(b,3);
C= sum(b,3)/N;

b1=b(:,:,1);
b2=b(:,:,round(N/4));


e1=(b1-C)/norm(b1-C);
e2=(b2-C)/norm(b2-C);
np=cross(e1, e2); 
np=np/norm(np);
figure
hold off
plot3(b(1,:),b(2,:),b(3,:),'*r')
hold on
plot3(squeeze(b(1,1,:)),squeeze(b(2,1,:)),squeeze(b(3,1,:)),'-')
quiver3(C(1,:),C(2,:),C(3,:),np(1,:),np(2,:),np(3,:),'b')
quiver3(C(1,:),C(2,:),C(3,:),e1(1,:),e1(2,:),e1(3,:),'g')
quiver3(C(1,:),C(2,:),C(3,:),e2(1,:),e2(2,:),e2(3,:),'m')
plot3(squeeze(b(1,:,1)),squeeze(b(2,:,1)),squeeze(b(3,:,1)),'o')
axis equal


for ipl=1:Npl 
    if np(1,ipl)'*np0(1)<0
        b(:,ipl,:)=b(:,ipl,end:-1:1);
        b1(:,ipl)=b(:,ipl,1);
        b2(:,ipl)=b(:,ipl,round(N/4));
        
        
        e1(:,ipl)=(b1(:,ipl)-C(:,ipl))/norm(b1(:,ipl)-C(:,ipl));
        e2(:,ipl)=(b2(:,ipl)-C(:,ipl))/norm(b2(:,ipl)-C(:,ipl));
        np(:,ipl)=cross(e1(:,ipl), e2(:,ipl));
        np(:,ipl)=np(:,ipl)/norm(np(:,ipl));
        
    end
end
figure
hold off
plot3(b(1,:),b(2,:),b(3,:),'*r')
hold on
quiver3(C(1,:),C(2,:),C(3,:),np(1,:),np(2,:),np(3,:),'b')
quiver3(C(1,:),C(2,:),C(3,:),e1(1,:),e1(2,:),e1(3,:),'g')
quiver3(C(1,:),C(2,:),C(3,:),e2(1,:),e2(2,:),e2(3,:),'m')
plot3(squeeze(b(1,:,1)),squeeze(b(2,:,1)),squeeze(b(3,:,1)),'*')
axis equal
plot3(squeeze(b(1,:,1)),squeeze(b(2,:,1)),squeeze(b(3,:,1)),'o')
plot3(squeeze(b(1,:,floor(size(b,3)/2))),squeeze(b(2,:,floor(size(b,3)/2))),squeeze(b(3,:,floor(size(b,3)/2))),'om')
plot3(squeeze(b(1,:,floor(size(b,3)/4))),squeeze(b(2,:,floor(size(b,3)/4))),squeeze(b(3,:,floor(size(b,3)/4))),'ok')

for ipl=2:Npl
    if e2(1,ipl)'*e2(1,1)<0 %confocal + jackie
        b(:,ipl,:)=b(:,ipl,[floor(size(b,3)/2):end,2:floor(size(b,3)/2)]);
        b1(:,ipl)=b(:,ipl,1);
        b2(:,ipl)=b(:,ipl,round(N/4));
        e1(:,ipl)=(b1(:,ipl)-C(:,ipl))/norm(b1(:,ipl)-C(:,ipl));
        e2(:,ipl)=(b2(:,ipl)-C(:,ipl))/norm(b2(:,ipl)-C(:,ipl));
        np(:,ipl)=cross(e1(:,ipl), e2(:,ipl));
        np(:,ipl)=np(:,ipl)/norm(np(:,ipl));        
    end
end
figure (4)
hold off
plot3(b(1,:),b(2,:),b(3,:),'*r')
hold on
quiver3(C(1,:),C(2,:),C(3,:),np(1,:),np(2,:),np(3,:),'b')
quiver3(C(1,:),C(2,:),C(3,:),e1(1,:),e1(2,:),e1(3,:),'g')
quiver3(C(1,:),C(2,:),C(3,:),e2(1,:),e2(2,:),e2(3,:),'m')
plot3(squeeze(b(1,:,1)),squeeze(b(2,:,1)),squeeze(b(3,:,1)),'*')
axis equal
plot3(squeeze(b(1,:,1)),squeeze(b(2,:,1)),squeeze(b(3,:,1)),'o')
plot3(squeeze(b(1,:,13)),squeeze(b(2,:,13)),squeeze(b(3,:,13)),'om')
