function [Ip,X,Y,Z]=im2plane(vol,np,C,R,dx,dy,dz,p)
% Convert All the variables are in pixel units
% the starting plane is in the x y plane with np=(0,0,1) and C=(0,0,0)
% then it si rotated with respect to y and then to z to match the
% orietatiopn of the desired np
% last step, it is translated to the center C
% vol(:,:,nz): image volume (true color)
% C: center of the region of interest
% R: dimension of the cross section to plot
% Dpix: thikness of the plane
% np normal to the plane
% Ip: figure on the cross section
% b : coordinates of the selected pixels

% vol=im2double(vol);
[X,Y]=meshgrid((-R/dx:R/dx)*dx,(-R/dx:R/dx)*dx);
Z=X*0;
nt=[0;0;1];
% surf(X,Y,Z);
% hold on
C0=[0;0;0];
% quiver3(C0(1),C0(2),C0(3),nt(1),nt(2),nt(3))
[THt,PHIt,Rt] = cart2sph(0,0,1);
%% rotation in x direction
[THn,PHIn,Rn] = cart2sph(np(1),np(2),np(3));

b=twod_rotationx([X(:)';Y(:)';Z(:)'],PHIn-PHIt);
nt2=twod_rotationx(nt,PHIn-PHIt);
% quiver3(C0(1),C0(2),C0(3),nt2(1),nt2(2),nt2(3))
[THt,PHIt,Rt] = cart2sph(nt2(1),nt2(2),nt2(3));

%rotation around z
nt3=twod_rotationZ([nt2(1,:);nt2(2,:);nt2(3,:)],THn-THt);
% quiver3(C0(1),C0(2),C0(3),nt3(1),nt3(2),nt3(3),10)

b=twod_rotationZ([b(1,:);b(2,:);b(3,:)],THn-THt);
%
% % rotation in y direction
% [THETAn] = cart2pol(np(1),np(3));
% [THETA] = cart2pol(0,1);
% b=twod_rotationy(b,THETAn-THETA);
b=reshape(b,3,size(X,1),size(X,2));
X=squeeze(b(1,:,:));
Y=squeeze(b(2,:,:));
Z=squeeze(b(3,:,:));
% hold on
% surf (X,Y,Z)
% translate to C
X=X+C(1);
Y=Y+C(2);
Z=Z+C(3);

% find color at (X,Y,Z) points
     Ip=im2uint16(zeros(size(X)));
     
for ipp=(0:p)-p/2
    Xt=X+np(1)*ipp*dx;
    Yt=Y+np(2)*ipp*dx;
    Zt=Z+np(3)*ipp*dx;
    
    % check if inside the image
    
ind = round(Xt(:)/dx)<=(size(vol,2)-1) & round(Xt(:)/dx)>=(2);
ind2= round(Yt(:)/dy)<=(size(vol,1)-1) & round(Yt(:)/dx)>=(2);
ind=ind.*ind2;
ind3= round(Zt(:)/dz)<=(size(vol,3)-1) & round(Zt(:)/dz)>=(2);
ind=ind.*ind3;
ind=logical(ind);
Xt= Xt(ind==1);
Yt= Yt(ind==1);
Zt= Zt(ind==1);

    Nr = round(Yt(:)/dy);
    Nc = round(Xt(:)/dx);
    Nz = round(Zt(:)/dz);
    idxm = Nr + (Nc-1)*size(vol,1) + (Nz-1)*size(vol,1)*size(vol,2);

    Ip(ind)=max([Ip(ind),vol(idxm)],[],2);
end
    

